diff --git a/src/main/java/net/minecraft/core/entity/Entity.java b/src/main/java/net/minecraft/core/entity/Entity.java
index b2bd80477..2db366c6d 100644
--- a/src/main/java/net/minecraft/core/entity/Entity.java
+++ b/src/main/java/net/minecraft/core/entity/Entity.java
@@ -12,10 +12,10 @@ import net.minecraft.client.gui.guidebook.mobs.MobInfoRegistry;
 import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.core.Global;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockFluid;
+import net.minecraft.core.block.FluidBlock;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.block.tag.BlockTags;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumBlockSoundEffectType;
 import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.item.ItemStack;
@@ -23,7 +23,7 @@ import net.minecraft.core.lang.I18n;
 import net.minecraft.core.util.helper.DamageType;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.phys.AABB;
-import net.minecraft.core.util.phys.Vec3d;
+import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.IVehicle;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.data.SynchedEntityData;
@@ -32,6 +32,11 @@ import org.jetbrains.annotations.Nullable;
 public abstract class Entity
     implements IVehicle
 {
+    public static final int DATA_SHARED_FLAGS_ID = 0;
+    public static final int FLAG_ONFIRE = 0;
+    public static final int FLAG_SNEAKING = 1;
+    public static final int FLAG_RIDING = 2;
+    public static final int FLAG_SPRINTING = 3;
     private static int entityCounter = 0;
     public int id = entityCounter++;
     public double viewScale = 1.0D;
@@ -52,7 +57,7 @@ public abstract class Entity
     public float xRot;
     public float yRotO;
     public float xRotO;
-    public final AABB bb = AABB.getBoundingBox(0.0D, 0.0D, 0.0D, 0.0D, 0.0D, 0.0D);
+    public final AABB bb = AABB.getPermanentBB(0.0D, 0.0D, 0.0D, 0.0D, 0.0D, 0.0D);
     public boolean onGround = false;
     public boolean horizontalCollision;
     public boolean verticalCollision;
@@ -107,11 +112,11 @@ public abstract class Entity
     public Entity(World world) {
         this.world = world;
         setPos(0.0D, 0.0D, 0.0D);
-        entityData.define(0, (byte) 0);
-        init();
+        entityData.define(DATA_SHARED_FLAGS_ID, (byte) 0);
+        defineSynchedData();
     }
 
-    protected abstract void init();
+    protected abstract void defineSynchedData();
 
     public void spawnInit()
     {
@@ -193,7 +198,7 @@ public abstract class Entity
         this.z = z;
         float center = bbWidth / 2.0F;
         float heightOfMob = bbHeight;
-        bb.setBounds(
+        bb.set(
                 x - (double)center,
                 (y - (double) heightOffset) + (double) ySlideOffset,
                 z - (double)center,
@@ -300,8 +305,8 @@ public abstract class Entity
 
         if (!world.isClientSide)
         {
-            setSharedFlag(0, remainingFireTicks > 0);
-            setSharedFlag(2, vehicle != null);
+            setSharedFlag(FLAG_ONFIRE, remainingFireTicks > 0);
+            setSharedFlag(FLAG_RIDING, vehicle != null);
         }
 
         firstTick = false;
@@ -311,7 +316,7 @@ public abstract class Entity
         {
             if(!wasInWater && !firstTick)
             {
-                float f = MathHelper.sqrt_double(xd * xd * 0.2D + yd * yd + zd * zd * 0.2D) * 0.2F;
+                float f = MathHelper.sqrt(xd * xd * 0.2D + yd * yd + zd * zd * 0.2D) * 0.2F;
                 if(f > 1.0F)
                 {
                     f = 1.0F;
@@ -326,7 +331,7 @@ public abstract class Entity
                     }
                 }
                 
-                float f1 = MathHelper.floor_double(bb.minY);
+                float f1 = MathHelper.floor(bb.minY);
                 for(int i = 0; (float)i < 1.0F + bbWidth * 20F; i++)
                 {
                     double offX = (random.nextFloat() * 2.0F - 1.0F) * bbWidth;
@@ -379,7 +384,7 @@ public abstract class Entity
 
     public boolean isFree(double x, double y, double z)
     {
-        AABB offsetBb = bb.getOffsetBoundingBox(x, y, z).expand(-0.01, -0.01, -0.01);
+        AABB offsetBb = bb.cloneMove(x, y, z).grow(-0.01, -0.01, -0.01);
         List<AABB> list = world.getCubes(this, offsetBb);
         if(list.size() > 0)
         {
@@ -393,7 +398,7 @@ public abstract class Entity
         if(noPhysics)
         {
         	onGround = false;
-            bb.offset(xd, yd, zd);
+            bb.move(xd, yd, zd);
             this.x = (bb.minX + bb.maxX) / 2D;
             this.y = (bb.minY + (double) heightOffset) - (double) ySlideOffset;
             this.z = (bb.minZ + bb.maxZ) / 2D;
@@ -420,7 +425,7 @@ public abstract class Entity
         if(sneakingOnGround)
         {
             double maxSneakOverhang = 0.05D;
-            for (; xd != 0.0 && this.world.getCubes(this, bb.getOffsetBoundingBox(xd, -1D, 0.0D)).size() == 0; oldXd = xd)
+            for (; xd != 0.0 && this.world.getCubes(this, bb.cloneMove(xd, -1D, 0.0D)).size() == 0; oldXd = xd)
             {
                 if(xd < maxSneakOverhang && xd >= -maxSneakOverhang)
                 {
@@ -437,7 +442,7 @@ public abstract class Entity
                     xd += maxSneakOverhang;
                 }
             }
-            for (; zd != 0.0D && world.getCubes(this, bb.getOffsetBoundingBox(0.0D, -1D, zd)).size() == 0; oldZd = zd)
+            for (; zd != 0.0D && world.getCubes(this, bb.cloneMove(0.0D, -1D, zd)).size() == 0; oldZd = zd)
             {
                 if(zd < maxSneakOverhang && zd >= -maxSneakOverhang)
                 {
@@ -456,13 +461,13 @@ public abstract class Entity
             }
         }
 
-        List<AABB> cubes = world.getCubes(this, bb.addCoord(xd, yd, zd));
+        List<AABB> cubes = world.getCubes(this, bb.expand(xd, yd, zd));
         for (AABB aabb : cubes)
         {
-            yd = aabb.calculateYOffset(bb, yd);
+            yd = aabb.clipYCollide(bb, yd);
         }
 
-        bb.offset(0.0D, yd, 0.0D);
+        bb.move(0.0D, yd, 0.0D);
         if(!slide && oldYd != yd)
         {
             xd = yd = zd = 0.0D;
@@ -470,20 +475,20 @@ public abstract class Entity
         boolean flag1 = onGround || oldYd != yd && oldYd < 0.0D;
         for (AABB aabb : cubes)
         {
-            xd = aabb.calculateXOffset(bb, xd);
+            xd = aabb.clipXCollide(bb, xd);
         }
 
-        bb.offset(xd, 0.0D, 0.0D);
+        bb.move(xd, 0.0D, 0.0D);
         if(!slide && oldXd != xd)
         {
             xd = yd = zd = 0.0D;
         }
         for (AABB aabb : cubes)
         {
-            zd = aabb.calculateZOffset(bb, zd);
+            zd = aabb.clipZCollide(bb, zd);
         }
 
-        bb.offset(0.0D, 0.0D, zd);
+        bb.move(0.0D, 0.0D, zd);
         if(!slide && oldZd != zd)
         {
             xd = yd = zd = 0.0D;
@@ -498,30 +503,30 @@ public abstract class Entity
             zd = oldZd;
             AABB axisalignedbb1 = bb.copy();
             bb.setBB(bbCopy);
-            List<AABB> list1 = world.getCubes(this, bb.addCoord(xd, yd, zd));
+            List<AABB> list1 = world.getCubes(this, bb.expand(xd, yd, zd));
             for (AABB aabb : list1) {
-                yd = aabb.calculateYOffset(bb, yd);
+                yd = aabb.clipYCollide(bb, yd);
             }
 
-            bb.offset(0.0D, yd, 0.0D);
+            bb.move(0.0D, yd, 0.0D);
             if(!slide && oldYd != yd)
             {
                 xd = yd = zd = 0.0D;
             }
             for (AABB aabb : list1) {
-                xd = aabb.calculateXOffset(bb, xd);
+                xd = aabb.clipXCollide(bb, xd);
             }
 
-            bb.offset(xd, 0.0D, 0.0D);
+            bb.move(xd, 0.0D, 0.0D);
             if(!slide && oldXd != xd)
             {
                 xd = yd = zd = 0.0D;
             }
             for (AABB aabb : list1) {
-                zd = aabb.calculateZOffset(bb, zd);
+                zd = aabb.clipZCollide(bb, zd);
             }
 
-            bb.offset(0.0D, 0.0D, zd);
+            bb.move(0.0D, 0.0D, zd);
             if(!slide && oldZd != zd)
             {
                 xd = yd = zd = 0.0D;
@@ -533,10 +538,10 @@ public abstract class Entity
             {
                 yd = -footSize;
                 for (AABB aabb : list1) {
-                    yd = aabb.calculateYOffset(bb, yd);
+                    yd = aabb.clipYCollide(bb, yd);
                 }
 
-                bb.offset(0.0D, yd, 0.0D);
+                bb.move(0.0D, yd, 0.0D);
             }
             if(oldX * oldX + oldZ * oldZ >= xd * xd + zd * zd)
             {
@@ -547,7 +552,7 @@ public abstract class Entity
             }
         }
         //fix for entity jitter when blasted by cannonballs (can cause some client-side jitter when entity is under a ceiling. unsure exactly why)
-        if (!this.world.isClientSide || this instanceof EntityPlayer || !(this instanceof EntityLiving)) {
+        if (!this.world.isClientSide || this instanceof Player || !(this instanceof Mob)) {
             this.x = (bb.minX + bb.maxX) / 2D;
             this.y = (bb.minY + (double) heightOffset) - (double) ySlideOffset;
             this.z = (bb.minZ + bb.maxZ) / 2D;
@@ -573,14 +578,14 @@ public abstract class Entity
         double d10 = this.x - d3;
         double d12 = this.z - d4;
         if(makeStepSound() && !sneakingOnGround && vehicle == null) {
-            walkDist += (double) MathHelper.sqrt_double(d10 * d10 + d12 * d12) * 0.6;
+            walkDist += (double) MathHelper.sqrt(d10 * d10 + d12 * d12) * 0.6;
             
             // Tiny bounding box
-            AABB boundingBox = AABB.getBoundingBox(this.x - 0.01, this.bb.minY - 0.01, this.z - 0.01, this.x + 0.01, this.bb.minY + 0.01, this.z + 0.01);
+            AABB boundingBox = AABB.getPermanentBB(this.x - 0.01, this.bb.minY - 0.01, this.z - 0.01, this.x + 0.01, this.bb.minY + 0.01, this.z + 0.01);
 
-            int blockX = MathHelper.floor_double(this.x);
-            int blockY = MathHelper.floor_double(boundingBox.minY);
-            int blockZ = MathHelper.floor_double(this.z);
+            int blockX = MathHelper.floor(this.x);
+            int blockY = MathHelper.floor(boundingBox.minY);
+            int blockZ = MathHelper.floor(this.z);
             
             Block blockWalkedOn = null;
 
@@ -607,7 +612,7 @@ public abstract class Entity
             }
             
             // Check for snow layers
-            int blockYUp = MathHelper.floor_double(boundingBox.maxY);
+            int blockYUp = MathHelper.floor(boundingBox.maxY);
             Block blockAbove = world.getBlock(blockX, blockYUp, blockZ);
             if(blockAbove != null && blockAbove.hasTag(BlockTags.OVERRIDE_STEPSOUND)) {
             	blockWalkedOn = blockAbove;
@@ -625,12 +630,12 @@ public abstract class Entity
                 }
             }
         }
-        int minX = MathHelper.floor_double(bb.minX + 0.001D);
-        int minY = MathHelper.floor_double(bb.minY + 0.001D);
-        int minZ = MathHelper.floor_double(bb.minZ + 0.001D);
-        int maxX = MathHelper.floor_double(bb.maxX - 0.001D);
-        int maxY = MathHelper.floor_double(bb.maxY - 0.001D);
-        int maxZ = MathHelper.floor_double(bb.maxZ - 0.001D);
+        int minX = MathHelper.floor(bb.minX + 0.001D);
+        int minY = MathHelper.floor(bb.minY + 0.001D);
+        int minZ = MathHelper.floor(bb.minZ + 0.001D);
+        int maxX = MathHelper.floor(bb.maxX - 0.001D);
+        int maxY = MathHelper.floor(bb.maxY - 0.001D);
+        int maxZ = MathHelper.floor(bb.maxZ - 0.001D);
         if(world.areBlocksLoaded(minX, minY, minZ, maxX, maxY, maxZ))
         {
             for(int _x = minX; _x <= maxX; _x++)
@@ -710,17 +715,17 @@ public abstract class Entity
         }
     }
 
-    protected void causeFallDamage(float f)
+    protected void causeFallDamage(float distance)
     {
         if (passenger != null)
         {
-            passenger.causeFallDamage(f);
+            passenger.causeFallDamage(distance);
         }
     }
 
     public boolean isInWaterOrRain()
     {
-        return wasInWater || world.canBlockBeRainedOn(MathHelper.floor_double(x), MathHelper.floor_double(y), MathHelper.floor_double(z));
+        return wasInWater || world.canBlockBeRainedOn(MathHelper.floor(x), MathHelper.floor(y), MathHelper.floor(z));
     }
 
     public boolean isInWater()
@@ -736,13 +741,13 @@ public abstract class Entity
     public boolean isUnderLiquid(Material material)
     {
         double d = y + (double) getHeadHeight();
-        int i = MathHelper.floor_double(x);
-        int j = MathHelper.floor_float(MathHelper.floor_double(d));
-        int k = MathHelper.floor_double(z);
+        int i = MathHelper.floor(x);
+        int j = MathHelper.floor_float(MathHelper.floor(d));
+        int k = MathHelper.floor(z);
         int l = world.getBlockId(i, j, k);
         if(l != 0 && Block.blocksList[l].blockMaterial == material)
         {
-            float f = BlockFluid.getWaterVolume(world.getBlockMetadata(i, j, k)) - 0.2F;
+            float f = FluidBlock.getWaterVolume(world.getBlockMetadata(i, j, k)) - 0.2F;
             float f1 = (float)(j + 1) - f;
             return d < (double)f1;
         } else
@@ -777,8 +782,8 @@ public abstract class Entity
         f *= f3;
         f1 *= f3;
 
-        float sinYaw = MathHelper.sin((yRot * 3.141593F) / 180F);
-        float cosYaw = MathHelper.cos((yRot * 3.141593F) / 180F);
+        float sinYaw = MathHelper.sin((yRot * MathHelper.PI) / 180F);
+        float cosYaw = MathHelper.cos((yRot * MathHelper.PI) / 180F);
         xd += f * cosYaw - f1 * sinYaw ;
         zd += f1 * cosYaw + f * sinYaw;
     }
@@ -788,11 +793,11 @@ public abstract class Entity
     	if(Global.accessor.isFullbrightEnabled()) {
     		return 1.0f;
     	}
-        int i = MathHelper.floor_double(x);
+        int i = MathHelper.floor(x);
         double d = (bb.maxY - bb.minY) * 0.66D;
-        int j = MathHelper.floor_double((y - (double) heightOffset) + d);
-        int k = MathHelper.floor_double(z);
-        if(world != null && world.areBlocksLoaded(MathHelper.floor_double(bb.minX), MathHelper.floor_double(bb.minY), MathHelper.floor_double(bb.minZ), MathHelper.floor_double(bb.maxX), MathHelper.floor_double(bb.maxY), MathHelper.floor_double(bb.maxZ)))
+        int j = MathHelper.floor((y - (double) heightOffset) + d);
+        int k = MathHelper.floor(z);
+        if(world != null && world.areBlocksLoaded(MathHelper.floor(bb.minX), MathHelper.floor(bb.minY), MathHelper.floor(bb.minZ), MathHelper.floor(bb.maxX), MathHelper.floor(bb.maxY), MathHelper.floor(bb.maxZ)))
         {
             float f1 = world.getLightBrightness(i, j, k);
             if(f1 < entityBrightness)
@@ -806,16 +811,16 @@ public abstract class Entity
         }
     }
     
-    public int getLightmapCoord(float partialTicks) {
+    public int getLightmapCoord(float partialTick) {
     	if(world == null) {
     		// Happens when the guidebook is rendered
     		return LightmapHelper.getLightmapCoord(15, 15);
     	}
     	
-    	int blockX = MathHelper.floor_double(x);
+    	int blockX = MathHelper.floor(x);
         double d = (bb.maxY - bb.minY) * 0.66D;
-    	int blockY = MathHelper.floor_double((y - (double) heightOffset) + d);
-    	int blockZ = MathHelper.floor_double(z);
+    	int blockY = MathHelper.floor((y - (double) heightOffset) + d);
+    	int blockZ = MathHelper.floor(z);
     	
     	int skylight = world.getSavedLightValue(LightLayer.Sky, blockX, blockY, blockZ);
     	int blocklight = world.getSavedLightValue(LightLayer.Block, blockX, blockY, blockZ);
@@ -882,7 +887,7 @@ public abstract class Entity
         double d3 = x - d;
         double d4 = y - d1;
         double d5 = z - d2;
-        return MathHelper.sqrt_double(d3 * d3 + d4 * d4 + d5 * d5);
+        return MathHelper.sqrt(d3 * d3 + d4 * d4 + d5 * d5);
     }
 
     public double distanceToSqr(Entity entity)
@@ -893,7 +898,7 @@ public abstract class Entity
         return d * d + d1 * d1 + d2 * d2;
     }
 
-    public void playerTouch(EntityPlayer player)
+    public void playerTouch(Player player)
     {
     }
 
@@ -917,7 +922,7 @@ public abstract class Entity
         double d2 = MathHelper.abs_max(d, d1);
         if (d2 >= 0.01D)
         {
-            d2 = MathHelper.sqrt_double(d2);
+            d2 = MathHelper.sqrt(d2);
             d /= d2;
             d1 /= d2;
             double d3 = 1.0D / d2;
@@ -973,18 +978,18 @@ public abstract class Entity
     {
     }
 
-    public boolean shouldRender(Vec3d vec3d)
+    public boolean shouldRender(Vec3 vec3)
     {
-        double d = x - vec3d.xCoord;
-        double d1 = y - vec3d.yCoord;
-        double d2 = z - vec3d.zCoord;
+        double d = x - vec3.x;
+        double d1 = y - vec3.y;
+        double d2 = z - vec3.z;
         double d3 = d * d + d1 * d1 + d2 * d2;
         return shouldRenderAtSqrDistance(d3);
     }
 
     public boolean shouldRenderAtSqrDistance(double distance)
     {
-        double d1 = bb.getAverageEdgeLength();
+        double d1 = bb.getSize();
         d1 *= 64D * viewScale;
         return distance < d1 * d1;
     }
@@ -996,7 +1001,7 @@ public abstract class Entity
 
     public boolean save(CompoundTag tag)
     {
-        String s = getEntityString();
+        String s = getEncodeId();
         if(removed || s == null)
         {
             return false;
@@ -1013,7 +1018,7 @@ public abstract class Entity
     {
         tag.put("Pos", newDoubleList(new double[] { x, y + ySlideOffset, z }));
         tag.put("Motion", newDoubleList(new double[] { xd, yd, zd }));
-        tag.put("Rotation", newFloatNBTList(new float[] { yRot, xRot }));
+        tag.put("Rotation", newFloatList(new float[] { yRot, xRot }));
         tag.putFloat("FallDistance", fallDistance);
         tag.putShort("Fire", (short) remainingFireTicks);
         tag.putShort("Air", (short) airSupply);
@@ -1056,9 +1061,9 @@ public abstract class Entity
         readAdditionalSaveData(tag);
     }
 
-    protected final String getEntityString()
+    protected final String getEncodeId()
     {
-        return EntityDispatcher.getEntityString(this);
+        return EntityDispatcher.getEncodeId(this);
     }
 
     public abstract void readAdditionalSaveData(CompoundTag tag);
@@ -1076,7 +1081,7 @@ public abstract class Entity
         return list;
     }
 
-    protected ListTag newFloatNBTList(float[] array)
+    protected ListTag newFloatList(float[] array)
     {
         ListTag list = new ListTag();
         for (float f : array)
@@ -1092,20 +1097,20 @@ public abstract class Entity
         return bbHeight / 2.0F;
     }
 
-    public EntityItem spawnAtLocation(int itemId, int stackSize)
+    public ItemEntity spawnAtLocation(int itemId, int stackSize)
     {
         return spawnAtLocation(itemId, stackSize, 0.0F);
     }
 
-    public EntityItem spawnAtLocation(int itemId, int stackSize, float verticalOffset)
+    public ItemEntity spawnAtLocation(int itemId, int stackSize, float verticalOffset)
     {
         return spawnAtLocation(new ItemStack(itemId, stackSize, 0), verticalOffset);
     }
 
-    public EntityItem spawnAtLocation(ItemStack itemStack, float verticalOffset)
+    public ItemEntity spawnAtLocation(ItemStack itemStack, float verticalOffset)
     {
-        EntityItem entityitem = new EntityItem(world, x, y + verticalOffset, z, itemStack);
-        entityitem.delayBeforeCanPickup = 10;
+        ItemEntity entityitem = new ItemEntity(world, x, y + verticalOffset, z, itemStack);
+        entityitem.pickupDelay = 10;
         world.entityJoinedWorld(entityitem);
         return entityitem;
     }
@@ -1122,9 +1127,9 @@ public abstract class Entity
             float f = ((float)((i >> 0) % 2) - 0.5F) * bbWidth * 0.9F;
             float f1 = ((float)((i >> 1) % 2) - 0.5F) * 0.1F;
             float f2 = ((float)((i >> 2) % 2) - 0.5F) * bbWidth * 0.9F;
-            int j = MathHelper.floor_double(x + (double)f);
-            int k = MathHelper.floor_double(y + (double) getHeadHeight() + (double)f1);
-            int l = MathHelper.floor_double(z + (double)f2);
+            int j = MathHelper.floor(x + (double)f);
+            int k = MathHelper.floor(y + (double) getHeadHeight() + (double)f1);
+            int l = MathHelper.floor(z + (double)f2);
             if(world.isBlockNormalCube(j, k, l))
             {
                 return true;
@@ -1134,7 +1139,7 @@ public abstract class Entity
         return false;
     }
 
-    public boolean interact(EntityPlayer entityplayer)
+    public boolean interact(Player entityplayer)
     {
         return false;
     }
@@ -1155,35 +1160,17 @@ public abstract class Entity
             return;
         }
         vehicle.positionRider();
-        entityRiderYawDelta += vehicle.getYRotDelta();
-        entityRiderPitchDelta += vehicle.getXRotDelta();
-        for(; entityRiderYawDelta >= 180D; entityRiderYawDelta -= 360D) { }
-        for(; entityRiderYawDelta < -180D; entityRiderYawDelta += 360D) { }
-        for(; entityRiderPitchDelta >= 180D; entityRiderPitchDelta -= 360D) { }
-        for(; entityRiderPitchDelta < -180D; entityRiderPitchDelta += 360D) { }
-        double d = entityRiderYawDelta * 0.5D;
-        double d1 = entityRiderPitchDelta * 0.5D;
-        float f = 10F;
-        if(d > (double)f)
-        {
-            d = f;
-        }
-        if(d < (double)(-f))
-        {
-            d = -f;
-        }
-        if(d1 > (double)f)
-        {
-            d1 = f;
-        }
-        if(d1 < (double)(-f))
-        {
-            d1 = -f;
-        }
-        entityRiderYawDelta -= d;
-        //entityRiderPitchDelta -= d1;
-        if(turnWithVehicle) yRot += d;
-        //rotationPitch += d1;
+        entityRiderYawDelta = MathHelper.normalizeRotation(entityRiderYawDelta + vehicle.getYRotDelta());
+        entityRiderPitchDelta = MathHelper.normalizeRotation(entityRiderPitchDelta + vehicle.getXRotDelta());
+
+        final float maxRot = 10F;
+        double yaw = MathHelper.clamp(entityRiderYawDelta / 2D, -maxRot, maxRot);
+        double pitch = MathHelper.clamp(entityRiderPitchDelta / 2D, -maxRot, maxRot);
+
+        entityRiderYawDelta -= yaw;
+        //entityRiderPitchDelta -= pitch;
+        if(turnWithVehicle && false) yRot += yaw;
+        //rotationPitch += pitch;
     }
 
     @Override
@@ -1273,7 +1260,7 @@ public abstract class Entity
         return 0.1F;
     }
 
-    public Vec3d getLookAngle()
+    public Vec3 getLookAngle()
     {
         return null;
     }
@@ -1309,22 +1296,22 @@ public abstract class Entity
 
     public boolean isOnFire()
     {
-        return !fireImmune && remainingFireTicks > 0 || getSharedFlag(0);
+        return !fireImmune && remainingFireTicks > 0 || getSharedFlag(FLAG_ONFIRE);
     }
 
     public boolean isPassenger()
     {
-        return vehicle != null || getSharedFlag(2);
+        return vehicle != null || getSharedFlag(FLAG_RIDING);
     }
 
     public boolean isSneaking()
     {
-        return getSharedFlag(1);
+        return getSharedFlag(FLAG_SNEAKING);
     }
     
     public void setSneaking(boolean flag)
     {
-    	setSharedFlag(1, flag);
+    	setSharedFlag(FLAG_SNEAKING, flag);
     }
 
     protected boolean getSharedFlag(int i)
@@ -1332,19 +1319,19 @@ public abstract class Entity
         return (entityData.getByte(0) & 1 << i) != 0;
     }
 
-    protected void setSharedFlag(int i, boolean flag)
+    protected void setSharedFlag(int id, boolean flag)
     {
-        byte byte0 = entityData.getByte(0);
+        byte sharedFlags = entityData.getByte(DATA_SHARED_FLAGS_ID);
         if(flag)
         {
-            entityData.set(0, (byte) (byte0 | 1 << i));
+            entityData.set(DATA_SHARED_FLAGS_ID, (byte) (sharedFlags | 1 << id));
         } else
         {
-            entityData.set(0, (byte) (byte0 & ~(1 << i)));
+            entityData.set(DATA_SHARED_FLAGS_ID, (byte) (sharedFlags & ~(1 << id)));
         }
     }
 
-    public void thunderHit(EntityLightningBolt bolt)
+    public void thunderHit(LightningEntity bolt)
     {
         burn(5);
         remainingFireTicks++;
@@ -1355,15 +1342,15 @@ public abstract class Entity
         maxFireTicks = remainingFireTicks;
     }
 
-    public void killed(EntityLiving entityliving)
+    public void killed(Mob entityliving)
     {
     }
 
     protected boolean checkInTile(double d, double d1, double d2)
     {
-        int i = MathHelper.floor_double(d);
-        int j = MathHelper.floor_double(d1);
-        int k = MathHelper.floor_double(d2);
+        int i = MathHelper.floor(d);
+        int j = MathHelper.floor(d1);
+        int k = MathHelper.floor(d2);
         double d3 = d - (double)i;
         double d4 = d1 - (double)j;
         double d5 = d2 - (double)k;
@@ -1442,12 +1429,12 @@ public abstract class Entity
 
     public boolean isSprinting()
     {
-        return getSharedFlag(3);
+        return getSharedFlag(FLAG_SPRINTING);
     }
 
     public void setSprinting(boolean sprinting)
     {
-        setSharedFlag(3, sprinting);
+        setSharedFlag(FLAG_SPRINTING, sprinting);
     }
 
     @Override
@@ -1472,28 +1459,28 @@ public abstract class Entity
 
     @Override
     public float getYRotDelta() {
-        return yRot - yRotO;
+        return (float) MathHelper.deltaAngle(yRot, yRotO);
     }
 
     @Override
     public float getXRotDelta() {
-        return xRot - xRotO;
+        return (float) MathHelper.deltaAngle(xRot, xRotO);
     }
 
     public static String getNameFromEntity(Entity entity, boolean useNickname){
         I18n translator = I18n.getInstance();
-        if (entity instanceof EntityLiving && useNickname){
-            if (!((EntityLiving) entity).nickname.isEmpty()){
-                return ((EntityLiving) entity).nickname;
+        if (entity instanceof Mob && useNickname){
+            if (!((Mob) entity).nickname.isEmpty()){
+                return ((Mob) entity).nickname;
             }
         }
-        if (entity instanceof EntityPlayer){
-            return ((EntityPlayer) entity).getDisplayName();
+        if (entity instanceof Player){
+            return ((Player) entity).getDisplayName();
         }
         if (MobInfoRegistry.getMobInfo(entity.getClass()) != null){
             return translator.translateKey(MobInfoRegistry.getMobInfo(entity.getClass()).getNameTranslationKey());
         }
-        String dispatcherName = EntityDispatcher.getEntityString(entity);
+        String dispatcherName = EntityDispatcher.getEncodeId(entity);
         if (dispatcherName != null) return dispatcherName;
         return entity.getClass().getSimpleName();
     }
